﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Gauges;
using Infragistics.Windows;

namespace LinearGaugeLabelOnNeedles
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent(); 
        }



        private void Button_Click(object sender, RoutedEventArgs e)
        {
            gauge.Value = 99;
        }
    }

    public class NeedleLabelBehvior : Behavior<XamLinearGauge>
    {
        #region Members

        ContentControl content = new ContentControl();

        #endregion

        #region Overrides

        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.LayoutUpdated += XamLinearGauge_LayoutUpdated;
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();
            AssociatedObject.LayoutUpdated -= XamLinearGauge_LayoutUpdated;
        }

        #endregion

        #region Event Handlers

        private void XamLinearGauge_LayoutUpdated(object sender, EventArgs e)
        {
            Canvas root = Utilities.GetDescendantFromName(AssociatedObject, "RootCanvas") as Canvas;
            if (root != null)
            {
                if (!root.Children.Contains(content))
                    root.Children.Add(content);

                double position = AssociatedObject.Value / (AssociatedObject.ActualMaximumValue - AssociatedObject.ActualMinimumValue);

                double startIndex = root.ActualWidth * AssociatedObject.ScaleStartExtent;
                double endIndex = root.ActualWidth - (root.ActualWidth * AssociatedObject.ScaleEndExtent);

                double pixelPosition = position * (root.ActualWidth - (startIndex + endIndex));

                Canvas.SetLeft(content, startIndex / 2 + pixelPosition);

            }
        }

        #endregion

        #region Properties

        #region Content

        public object Content
        {
            get { return (object)GetValue(ContentProperty); }
            set { SetValue(ContentProperty, value); }
        }

        public static readonly DependencyProperty ContentProperty =
            DependencyProperty.Register(
                "Content", 
                typeof(object), 
                typeof(NeedleLabelBehvior),
                new PropertyMetadata(null,
                    (ss, ee) =>
                    {
                        NeedleLabelBehvior behavior = ss as NeedleLabelBehvior;

                        behavior.content.Content = null;
                        behavior.content.Content = ee.NewValue;
                    }));
        
        #endregion

        #region ContentTemplate
        
        public DataTemplate ContentTemplate
        {
            get { return (DataTemplate)GetValue(ContentTemplateProperty); }
            set { SetValue(ContentTemplateProperty, value); }
        }

        public static readonly DependencyProperty ContentTemplateProperty =
            DependencyProperty.Register(
                "ContentTemplate",
                typeof(DataTemplate), 
                typeof(NeedleLabelBehvior), 
                new PropertyMetadata(null, 
                    (ss, ee) => 
                    {
                        NeedleLabelBehvior behavior = ss as NeedleLabelBehvior;

                        behavior.content.ContentTemplate = null;
                        behavior.content.ContentTemplate = ee.NewValue as DataTemplate;
                    }));
         
        #endregion

        #endregion
    }
}
